/*
Copyright 2021 The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package api

import (
	"io"
)

//go:generate go run github.com/maxbrunsfeld/counterfeiter/v6 -generate

//counterfeiter:generate . File

// TODO(api): Populate interface and regenerate mocks
type File interface {
	Parse(io.Reader) (Document, error)
}

//counterfeiter:generate . Document

// Document is an interface satisfied by the following types:
// - `Proposal` (KEP)
// - `PRRApproval`
// - `Receipt` (coming soon)
// TODO(api): Populate interface and regenerate mocks
type Document interface {
	Validate() error
}

type Parser struct {
	Groups       []string
	PRRApprovers []string

	Errors []error
}

// TODO: Can we come up with a better name/location for this?
func IsOneOf(check string, slice []string) bool {
	for _, v := range slice {
		if v == check {
			return true
		}
	}

	return false
}
